﻿using Microsoft.AspNetCore.Mvc;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Three.Services;
using Three.Models;
namespace Three.Controllers
{
    public class EmployeeController : Controller
    {
        private readonly IEmployeeService _employeeService;
        private readonly IDepartmentService _departmentService;

        public EmployeeController(IEmployeeService employeeService,IDepartmentService departmentService)
        {
            this._employeeService = employeeService;
            this._departmentService = departmentService;
        }
        public async Task<IActionResult> Index(int departmentId)
        {
            var department = await _departmentService.GetById(departmentId);
            ViewBag.Title = "Employees of " + department.Name;
            ViewBag.DepartmentId = departmentId;
            var employees = await _employeeService.GetByDepartmentId(departmentId);
            return View(employees);
        }
        public IActionResult Add(int departmentId)
        {
            ViewBag.Title = "Add Employee";
            return View(new Employee
            {
                DepartmentId = departmentId
            });
        }
        [HttpPost]
        public async Task<IActionResult> Add(Employee employee)
        {
            if(ModelState.IsValid)
            {
                await _employeeService.Add(employee);
            }
            //第二个参数，是个匿名类，他的departmentId必须和Index的类型及参数名一模一样。这里输入漏了一个t导致那边收到的是0
            return RedirectToAction(nameof(Index),new { departmentId = employee.DepartmentId });
        }
        public async Task<IActionResult> Fire(int employeeId)
        {
            var employee = await _employeeService.Fire(employeeId);
            return RedirectToAction(nameof(Index), new { departmentId = employee.DepartmentId });
        }
    }
}
